/** CLIENT-SIDE 
 * Anurag Bhandari (anurag.bhd@gmail.com)
 * Gagandeep Singh Walia (gagan.jld@hmail.com)
 * 
 * DESCRIPTION:
 * The main program on peer which initiates the end user GUI.
 * 
 */

package p2pclient;
import javax.swing.UIManager;
import javax.swing.JLabel;
import javax.swing.JWindow;
import javax.swing.SwingUtilities;
import javax.swing.ImageIcon;
import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Frame;
import java.awt.Toolkit;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

public class Main {
    public static void main(String[] args) {
        // Display the splash screen
        SplashWindow sw = new SplashWindow("/p2pclient/images/about-banner.png", null, 3000);
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                try {
                    // Set the GUI look-n-feel to match system default instead of boring Java's Metal look
                    UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
                    System.out.println(UIManager.getSystemLookAndFeelClassName());
                }
                catch (Exception e) {
                    System.out.println(e.getMessage());
                }
                new ClientUI().setVisible(true);
            }
        });
    }
}

// Idea from: http://www.javaworld.com/javaworld/javatips/jw-javatip104.html
class SplashWindow extends JWindow
{
    public SplashWindow(String filename, Frame f, int waitTime)
    {
        super(f);
        JLabel l = new JLabel(new ImageIcon(getClass().getResource(filename)));
        getContentPane().add(l, BorderLayout.CENTER);
        pack();
        Dimension screenSize =
          Toolkit.getDefaultToolkit().getScreenSize();
        Dimension labelSize = l.getPreferredSize();
        setLocation(screenSize.width/2 - (labelSize.width/2),
                    screenSize.height/2 - (labelSize.height/2));
        addMouseListener(new MouseAdapter()
            {
                public void mousePressed(MouseEvent e)
                {
                    setVisible(false);
                    dispose();
                }
            });
        final int pause = waitTime;
        final Runnable closerRunner = new Runnable()
            {
                public void run()
                {
                    setVisible(false);
                    dispose();
                }
            };
        Runnable waitRunner = new Runnable()
            {
                public void run()
                {
                    try
                        {
                            Thread.sleep(pause);
                            SwingUtilities.invokeAndWait(closerRunner);
                        }
                    catch(Exception e)
                        {
                            e.printStackTrace();
                            // can catch InvocationTargetException
                            // can catch InterruptedException
                        }
                }
            };
        setVisible(true);
        Thread splashThread = new Thread(waitRunner, "SplashThread");
        splashThread.start();
    }
}