/** SERVER-SIDE 
 * Anurag Bhandari (anurag.bhd@gmail.com)
 * Gagandeep Singh Walia (gagan.jld@hmail.com)
 * 
 * DESCRIPTION:
 * The main program run on the central server as the server app. It initiates 
 * the ClientThread program to handle requests coming from clients.
 * 
 */

package p2pserver;

import java.io.IOException;
import java.net.ServerSocket;
import java.net.Socket;
import java.sql.SQLException;

public class Server {

    public static void main(String st[]) throws SQLException, ClassNotFoundException {
        ServerSocket server = null;
        try {
            server = new ServerSocket(4321);
        } catch (IOException e) {
            System.out.println("Could not listen on port 4321");
            System.exit(-1);
        }
        while (true) {
            System.out.println("Waiting for activity...");
            Socket client = null;
            try {
                client = server.accept();
            } catch (IOException e) {
                System.out.println("Accept failed: 4321");
                System.exit(-1);
            }

            ClientThread cs = new ClientThread(client);
            // When the constructor has finished executing its code, it sets "ready" to true
            if (cs.ready == true) {
                System.out.println("Starting client thread");
                cs.start();
            }
        }
    }
}